#include "plugin-icns.h"


GdkPixbuf * iIcons::get_pixbuf ()
{
	GdkPixbuf * temp;
	string final_name;
	
	temp = load_icns	 ("512","32");
	if(temp == NULL)
		temp = load_icns ("256","32");
	if(temp == NULL)
		temp = load_icns ("128","32");
	
	/*if (temp == NULL)
	{
		final_name = "/tmp/_128x128x32.png";
		g_print("PLUGIN:Filename to load: %s\n", final_name.c_str());	
		temp = gdk_pixbuf_new_from_file(final_name.c_str(),NULL);
	}*/
	

	if(temp == NULL)
	{
		return get_icon();
	}
	else
	{

		return temp;
	}

};

// ==================== LOAD ICNS ======================= //
GdkPixbuf* iIcons::	load_icns	(string size, string depth)
{
	GdkPixbuf * temp;
	string final_name;
	//FIXME: Take care of the spaces and change them for "\ "
	string cmd = "icns2png -x -s " + size +" -d "+ depth + " -o /tmp/ " + replace_spaces(m_filename);
	g_print("PLUGIN: Loading icon (%s)\n",m_filename.c_str());
	g_print("PLUGIN: %s\n",cmd.c_str());

	//Launch icns2png
	g_spawn_command_line_sync (cmd.c_str(), NULL, NULL, NULL, NULL);
	
	//Get the created file
	int last_slash = m_filename.rfind("/");
	int last_dot =   m_filename.rfind(".");
	
	//g_print("PLUGIN SLASH:%i DOT:%i\n",last_slash, last_dot);

	final_name = "/tmp"+ m_filename.substr(last_slash, last_dot - last_slash ) +"_"+size+"x"+size+"x"+depth+".png";
	g_print("PLUGIN:Filename to load: %s\n", final_name.c_str());
	temp = gdk_pixbuf_new_from_file(final_name.c_str(),NULL);
	if(temp != NULL)
	{
		string cmd = "rm \"" + final_name + "\"";
		g_spawn_command_line_sync (cmd.c_str(), NULL, NULL, NULL, NULL);
	}
	
	return temp;
}

// ==================== REPLACE SPACES ======================= //
string iIcons::replace_spaces	(string str)
{
	int pos = -2;
	while(str.find(" ",pos+2) != string::npos)
	{
		pos = str.find(" ",pos+2);
		str = str.replace(pos,1,"\\ ");
		printf("PLUGIN STR: %s\n",str.c_str());
	}
	return str;
	
	/*pos = str.find(" ",0);
	if(pos != string::npos)
	{
		str = str.replace(pos,1,"\\ ");
	}*/
	return str;
}
