// =================================== GLOOBUS =============================================== //
// ==																						== //	
// ==  Gloobus, a quicklook for linux														== //
// ==																						== //
// ==	Project site: http://launchpad.net/gloobus 											== //
// ==																						== //
// ==	This is a quicklook for linux, it is based on a plugin architecture so everyone can == //
// ==   develop his own plugin to preview any filetype and do whatever he wants				== //
// ==																						== //
// ==   Plase, consider to donate cause it takes me a lot of time and efforts, and you know,== //
// ==   getting a recompense for you job allways makes you do it better						== //
// ==																						== //
// ==																						== //
// ==	Auhtor: Jordi Hernandez Puigdellívol <guitarboy000@gmail.com>						== //
// =========================================================================================== //   
#ifndef _PMANAGER_
#define	_PMANAGER_

#include <dlfcn.h>
#include <cstdlib>
#include <stdlib.h>

#include <string.h>
#include <map>
#include <vector>
#include <list>

#include <gio/gio.h>

#include "gloobus-preview-interface-main.h"


#define MANAGER_VERSION 1

using namespace std;

class pluginManager
{

	private:
		list<void*> 			m_dl_list;
  		list<void *>::iterator  m_itr;
		string					m_filename;
		string					m_filetype;
		string					m_uri;
		string					m_classtype;

	public:
								pluginManager			();	
								~pluginManager			();

		void 					load_plugins			();
		void					unload_plugins			();
		void					get_info				(string filename);
		string					get_filetype			();  					//Returns filetype;
		string					get_classtype			();
		string					get_uri					();
		string					search_for_plugin		(string filename);  	//Returns the key name of plugin;
};

#endif
